{% extends 'base.html.twig' %}

{% block stylesheets %}
    {{ parent() }}
    {{ encore_entry_link_tags('property_vacancy_management/property_excel_import/overview') }}
{% endblock %}

{% block javascripts %}
    {{ parent() }}
    {{ encore_entry_script_tags('property_vacancy_management/property_excel_import/overview') }}
{% endblock %}

{% block mainHeader %}
    <div class="container-fluid d-flex bg-white justify-content-start px-4 py-4">
        <span class="text-primary header-brand">Excel-Import</span>
    </div>
{% endblock %}

{% block main %}
    <div class="container-lg mt-4">
        <div class="mdc-card mb-4">
            <div class="accordion">
                <div class="accordion-item">
                    <h2 class="accordion-header">
                        <button class="accordion-button fs-5" type="button" data-coreui-toggle="collapse" data-coreui-target="#property_excel_import_upload_container" aria-expanded="true" aria-controls="property_excel_import_upload_container">
                            Excel-Import
                        </button>
                    </h2>
                    <div id="property_excel_import_upload_container" class="accordion-collapse collapse show">
                        <div class="p-3">
                            <div class="mb-3">
                                <div class="row">
                                    <div class="col-lg-8">
                                        <p id="tutorial-paragraph" class="py-2">
                                            Der Excel-Import gibt Ihnen die Möglichkeit, eine Liste erfasster Nutzungseinheiten und Leerstandsobjekte einzlesen.
                                            Bitte nutzen Sie dazu ausschließlich die LeAn®-Vorlagendatei, die Sie über den <span class="d-none d-lg-inline">nebenstehenden </span>Button &raquo;Vorlage herunterladen&laquo; downloaden können.
                                        </p>
                                        <p>
                                            Die ausgefüllte Datei können Sie hier hochladen, was den Verarbeitungsprozess startet, der im Hintergrund läuft und einige Minuten dauern kann.
                                        </p>
                                    </div>
                                    <div class="col-lg-4 text-lg-end">
                                        <a href="{{ path('property_vacancy_management_property_excel_import_template_download') }}" class="mdc-button mdc-button--icon-leading">
                                            <span class="mdc-button__ripple"></span>
                                            <i class="material-icons mdc-button__icon" aria-hidden="true">file_download</i>
                                            <span class="mdc-button__label">Vorlage herunterladen</span>
                                        </a>
                                    </div>
                                </div>
                            </div>
                            {{ form_start(propertyExcelImportForm) }}
                            <div class="mb-4">
                                <div class="row">
                                    <div class="col-lg-8">
                                        <label for="formFileLg" class="form-label"><strong>Excel-Datei:</strong></label>
                                        <div class="d-flex align-items-center gap-3">
                                            {{ form_widget(propertyExcelImportForm.excelFile, {'attr': {'class': 'form-control'}}) }}
                                            {{ form_widget(propertyExcelImportForm.upload, {'label': 'HOCHLADEN', 'attr': {'class': 'mdc-button mdc-button--raised'}}) }}
                                        </div>
                                        {% for message in app.flashes('error') %}
                                            <div class="alert alert-danger" role="alert">
                                                {{ message }}
                                            </div>
                                        {% endfor %}
                                    </div>
                                </div>
                            </div>
                            {{ form_row(propertyExcelImportForm._token) }}
                            {{ form_end(propertyExcelImportForm) }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="mdc-card mb-4">
            <div class="accordion">
                <div class="accordion-item">
                    <h2 class="accordion-header">
                        <button class="accordion-button fs-5" type="button" data-coreui-toggle="collapse" data-coreui-target="#property_excel_import_imports_container" aria-expanded="true" aria-controls="property_excel_import_imports_container">
                            Importe  <span class="ms-1">({{ propertyExcelImports|length }})</span>
                        </button>
                    </h2>
                    <div id="property_excel_import_imports_container" class="accordion-collapse collapse show">
                        <div class="d-flex flex-column">
                            {% include 'property_vacancy_management/component/property_excel_import/property_excel_import_list_component.html.twig' with {
                                'idPrefix': 'property_excel_import_',
                                'massOperation': false,
                                'pagination': true,
                                'sortable': true,
                                'listItems': propertyExcelImports,
                            } %}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    {% for propertyExcelImport in propertyExcelImports %}
        {% if propertyExcelImport.getProcessPropertyExcelImportTask().getTaskStatus().name == 'FAILED' %}
            <div class="modal fade" id="excel-import-validation-errors-{{ propertyExcelImport.getId() }}" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog modal-lg" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">{{ propertyExcelImport.getFile().getFilename() }}</h5>
                            <button type="button" class="btn-close" data-coreui-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body">
                            {% if propertyExcelImport.getValidationErrors()|length == 1 and propertyExcelImport.getValidationErrors()[0].row is null and propertyExcelImport.getValidationErrors()[0].col is null %}
                                <div class="alert alert-danger">{{ propertyExcelImport.getValidationErrors()[0].error }}</div>
                            {% else %}
                                <div class="mdc-data-table w-100">
                                    <div class="mdc-data-table__table-container">
                                        <table class="mdc-data-table__table" aria-label="Persons">
                                            <thead>
                                            <tr class="mdc-data-table__header-row">
                                                <th class="mdc-data-table__header-cell" role="columnheader" scope="col">Zeile</th>
                                                <th class="mdc-data-table__header-cell" role="columnheader" scope="col">Spalte</th>
                                                <th class="mdc-data-table__header-cell" role="columnheader" scope="col">Fehler</th>
                                            </tr>
                                            </thead>
                                            <tbody class="mdc-data-table__content">
                                            {% for validationError in propertyExcelImport.getValidationErrors() %}
                                                {% if validationError.row is not null and validationError.col is not null %}
                                                <tr class="mdc-data-table__row">
                                                    <td class="mdc-data-table__cell">{{ validationError.row }}</td>
                                                    <td class="mdc-data-table__cell">{{ excelHeaderCols[validationError.col] }}</td>
                                                    <td class="mdc-data-table__cell text-danger">{{ validationError.error }}</td>
                                                </tr>
                                                {% endif %}
                                            {% endfor %}
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            {% endif %}
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}
    {% endfor %}
{% endblock %}
